/*
 * Copyright (C) 2000  Anathoth Software (http://Anathoth.tripod.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/* This version: 1.1 */

import Prefs;
import java.io.*;
import javax.swing.undo.*;
import java.net.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;

import java.awt.*;
import java.awt.event.*;

public class decaf 
{
	public static String companyName = new String("Anathoth Software (http://Anathoth.tripod.com)");

	public static String defaultContent = new String(
		"Copyright (C) 2000  Anathoth Software (http://Anathoth.tripod.com)\n"
		+ "\nThis program is free software; you can redistribute it and/or"
		+ "\nmodify it under the terms of the GNU General Public License"
		+ "\nas published by the Free Software Foundation; either version 2"
		+ "\nof the License, or (at your option) any later version."
		+ "\n"
		+ "\nThis program is distributed in the hope that it will be useful,"
		+ "\nbut WITHOUT ANY WARRANTY; without even the implied warranty of"
		+ "\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the"
		+ "\nGNU General Public License for more details."
		+ "\n"
		+ "\nYou should have received a copy of the GNU General Public License"
		+ "\nalong with this program; if not, write to the Free Software"
		+ "\nFoundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA."
	);
	private boolean edited = false;
//edit fields

	public JTextField tPath;
	public JScrollPane tScroll;
	public JTextArea tField;

	public static Prefs prefsObject;


        public Component CreateComponents() 
	{
		JPanel some_components = new JPanel();

		JLabel pathLbl = new JLabel("Current Path / File:");
		some_components.add(pathLbl);

/* Path */ tPath = new JTextField(20);
		tPath.setToolTipText("Current PATH field");
		some_components.add(tPath);

		JButton bOpen = new JButton("<- Open this file");
		bOpen.addActionListener( new ActionListener ()
		 {
			public void actionPerformed(ActionEvent e)
			{
				fOpen();
			}
		 }
		);
		bOpen.setToolTipText("Opens the file in the PATH field");
		some_components.add(bOpen);

/* editor */    tField = new JTextArea(defaultContent, prefsObject.cols, prefsObject.rows);
		/*tField.addActionListener( new ActionListener()
		 {
			public void actionPerformed(ActionEvent e)
			{
				edited = true;
			}
		 }
		);*/
		tField.setTabSize(4);
		tField.setFont(new Font("Monospaced", Font.PLAIN, 12));
/* scrollbar */ tScroll = new JScrollPane(tField);
		some_components.add(tScroll);

		some_components.add(new JLabel("(c)2000 " + companyName + " "));

		return some_components;
	}
//--------=-------------------------------------------------==
public JMenuBar CreateMenuBar()
{
	JMenuBar menubar = new JMenuBar();

	JMenu fileMenu = new JMenu("File");
	fileMenu.setMnemonic( 'F' );	
	
	JMenuItem mNew = new JMenuItem("New");
	mNew.addActionListener(new ActionListener()
	 {
		public void actionPerformed(ActionEvent e)
		{
			fNew();
		}
	 }
	);
	mNew.setMnemonic( 'N' );
	fileMenu.add(mNew);

	JMenuItem mOpen = new JMenuItem("Open File in PATH Field");
	mOpen.addActionListener(new ActionListener()
	 {
		public void actionPerformed(ActionEvent e)
		{
			fOpen();
		}
	 }
	);
	mOpen.setMnemonic( 'O' );
	fileMenu.add(mOpen);

	JMenuItem mSave = new JMenuItem("Save");
	mSave.addActionListener(new ActionListener()
	 {
		public void actionPerformed(ActionEvent e)
		{
			fSave();
		}
	 }
	);
	mSave.setMnemonic( 'S' );
	fileMenu.add(mSave);

	JMenuItem mClose = new JMenuItem("Close");
	mClose.addActionListener(new ActionListener()
	 {
		public void actionPerformed(ActionEvent e)
		{
			fClose();
		}
	 }
	);
	mClose.setMnemonic('C');
	fileMenu.add(mClose);


	fileMenu.addSeparator();

	JMenuItem mQuit = new JMenuItem("Quit");
	mQuit.addActionListener(new ActionListener()
	 {
		public void actionPerformed(ActionEvent e)
		{
			fQuit();
		}
	 }
	);
	mQuit.setMnemonic( 'Q' );
	fileMenu.add(mQuit);

	menubar.add( fileMenu );




	JMenu javaMenu = new JMenu("Java");
	javaMenu.setMnemonic( 'J' );

	JMenuItem mCompile = new JMenuItem("Compile");
	mCompile.addActionListener(new ActionListener()
	 {
		public void actionPerformed(ActionEvent e)
		{
			fCompile();
		}
	 }
	);
	mCompile.setMnemonic( 'C' );
	javaMenu.add(mCompile);

	JMenuItem mRunApplication = new JMenuItem("Run as Application");
	mRunApplication.addActionListener(new ActionListener()
	 {
		public void actionPerformed(ActionEvent e)
		{
			fRunApplication();
		}
	 }
	);
	mRunApplication.setMnemonic( 'A' );
	javaMenu.add(mRunApplication);

		JMenuItem mRunAppletviewer = new JMenuItem("Run in Appletviewer");
		mRunAppletviewer.addActionListener(new ActionListener()
		 {
			public void actionPerformed(ActionEvent e)
			{
				fRunAppletviewer();
			}
		 }
		);
	mRunAppletviewer.setMnemonic( 'v' );
		javaMenu.add(mRunAppletviewer);

		JMenuItem mRunBrowser = new JMenuItem("Run in Browser");
		mRunBrowser.addActionListener(new ActionListener()
		 {
			public void actionPerformed(ActionEvent e)
			{
				fRunBrowser();
			}
		 }
		);
	mRunBrowser.setMnemonic( 'B' );
		javaMenu.add(mRunBrowser);

		JMenuItem mGenHTML = new JMenuItem("Generate HTML File");
		mGenHTML.addActionListener(new ActionListener()
		 {
			public void actionPerformed(ActionEvent e)
			{
				fGenHTML();
			}
		 }
		);
		mGenHTML.setMnemonic('H');
		javaMenu.add(mGenHTML);

	menubar.add(javaMenu);



	JMenu infoMenu = new JMenu("Info");
	infoMenu.setMnemonic('I');

	JMenuItem mPrefs = new JMenuItem("Prefs");
	mPrefs.addActionListener(new ActionListener()
	 {
		public void actionPerformed(ActionEvent e)
		{
			fPrefs();
		}
	 }
	);
	mPrefs.setMnemonic( 'P' );
	infoMenu.add(mPrefs);

	JMenuItem mLineNumber = new JMenuItem("Get Current Line Number");
	mLineNumber.addActionListener(new ActionListener()
	 {
		public void actionPerformed(ActionEvent e)
		{
			String line;
			try
			{
				line = new String(String.valueOf(tField.getLineOfOffset(tField.getCaretPosition()) + 1));
			}
			catch (BadLocationException ble) 
			{ 
				line = new String("unavailable");
			}
			JOptionPane.showMessageDialog(null, new JLabel("Current LineNumber is: " + line + "."), 
				"Current Line Number", JOptionPane.INFORMATION_MESSAGE);
			
		}
	 }
	);
	mLineNumber.setMnemonic( 'L' );
	infoMenu.add(mLineNumber);


	JMenuItem mTotalLines = new JMenuItem("Get Total Line Count");
	mTotalLines.addActionListener(new ActionListener()
	 {
		public void actionPerformed(ActionEvent e)
		{
			JOptionPane.showMessageDialog(null, new JLabel("Total Line Count is: " + String.valueOf(tField.getLineCount()) + "."), 
				"Total Line Count", JOptionPane.INFORMATION_MESSAGE);
		}
	 }
	);
	mTotalLines.setMnemonic( 'T' );
	infoMenu.add(mTotalLines);

	JMenuItem mAbout = new JMenuItem("About Decaf");
	mAbout.addActionListener(new ActionListener()
	 {
		public void actionPerformed(ActionEvent e)
		{
			String temp1 = new String(tPath.getText());
			tPath.setText("./decaf_docs");
			fRunBrowser();
			tPath.setText(temp1);
		}
	 }
	);
	infoMenu.add(mAbout);

	JMenuItem mLicense = new JMenuItem("Decaf License");
	mLicense.addActionListener(new ActionListener()
	 {
		public void actionPerformed(ActionEvent e)
		{
			JOptionPane.showMessageDialog(null, new JLabel("Decaf is under the GNU GENERAL PUBLIC LICENSE. Enjoy the no shareware fee!"), "License Info", JOptionPane.INFORMATION_MESSAGE);
		}
	 }
	);
	infoMenu.add(mLicense);
	
	
	
	menubar.add(infoMenu);	

	return menubar;
}
//--------=--=-=-=-=-=-=-=-=-==-=-=--==-=-=-=-=-=-=-=-=-=-=-==
	public static void main(String[] args) 
	{
		Toolkit theKit = Toolkit.getDefaultToolkit();
		JWindow splash = new JWindow(); //("Decaf Java Editor - Splash Screen");
		ImageIcon image = new ImageIcon("decaf_splash.gif");
		splash.getContentPane().add(new JLabel(image));
		splash.setSize(400, 200);
		Dimension winSize = theKit.getScreenSize();
		splash.setLocation(new Point(winSize.width/2 - image.getIconWidth()/2, winSize.height/2 - image.getIconHeight()/2)); 
			//in the center ^
		splash.setVisible(true);

		//set defaults, then open the prefs file to 
		//change them.
		//javacPath = new String("d:\\jdk1.2.2\\bin\\javac.exe");
		//javaPath  = new String("d:\\jdk1.2.2\\bin\\java.exe");
		prefsObject = new Prefs();
		
		try
		{
			prefsObject = prefsObject.read("decaf.prefs");
		}
		catch(FileNotFoundException e)
		{
			System.out.println("Error, using default prefs." + e);
			prefsObject = new Prefs(
			"c:\\jdk1.2.2\\bin\\java.exe", 
			"c:\\jdk1.2.2\\bin\\javac.exe",
			"c:\\jdk1.2.2\\bin\\appletviewer.exe",
			"c:\\Program Files\\Netscape\\Communicator\\Program\\netscape.exe",
			" height=\"200\" width=\"300\"> ",
			25, 75
			);
		}
		catch(ClassNotFoundException e)
		{
			System.out.println("Error, using default prefs." + e);
			prefsObject = new Prefs(
			"c:\\jdk1.2.2\\bin\\java.exe", 
			"c:\\jdk1.2.2\\bin\\javac.exe",
			"c:\\jdk1.2.2\\bin\\appletviewer.exe",
			"c:\\Program Files\\Netscape\\Communicator\\Program\\netscape.exe",
			" height=\"200\" width=\"300\"> ",
			25, 75
			);
		}
		catch(IOException e)
		{
			System.out.println("Error, using default prefs." + e);
			prefsObject = new Prefs(
			"c:\\jdk1.2.2\\bin\\java.exe", 
			"c:\\jdk1.2.2\\bin\\javac.exe",
			"c:\\jdk1.2.2\\bin\\appletviewer.exe",
			"c:\\Program Files\\Netscape\\Communicator\\Program\\netscape.exe",
			" height=\"200\" width=\"300\"> ",
			25, 75
			);
		}


		JFrame frame = new JFrame("Decaf Java Editor");
		decaf app = new decaf();

		
		JMenuBar mb = app.CreateMenuBar();
		frame.setJMenuBar(mb);
		

		Component contents = app.CreateComponents();
		frame.getContentPane().add(contents, BorderLayout.CENTER);

		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
		                System.exit(0);
			}
		});

		frame.setSize(600, 500);
		//frame.pack();
		frame.setVisible(true);

		try
		{
			app.tPath.setText(args[0]);
			app.fOpen();
		}
		catch(ArrayIndexOutOfBoundsException d) { ; }

		try
		{
			prefsObject.write(prefsObject, "decaf.prefs");
		}
		catch(FileNotFoundException e)
		{
			System.out.println("Error: " + e);
		}
		catch(IOException e)
		{
			System.out.println("Error: " + e);
		}



		splash.dispose();
	}
	
////////////////////////f-buttons//////////
	public void fNew() { tPath.setText(""); tField.setText(""); }
	public void fQuit() { System.exit(0); }
	public void fSave()
	{
		String text = new String(tField.getText());
		String path = new String(tPath.getText());
		try
		{
			FileWriter fw = new FileWriter(path);
			fw.write(text);
			fw.close();
		} 
		catch(IOException ioe )
		{
			System.out.println("IO error" + ioe);
		}
	}
	public void fClose()
	{
		tPath.setText(""); tField.setText("");
	}
	public void fOpen()
	{
		String path = new String(tPath.getText());
		try
		{
			int i = 0;
			FileReader fr = new FileReader(path);
			String text = new String("");
			while ( i != -1)
			{
				i = fr.read();
				if ( i != -1) text += (char)i;
			}
			tField.setText(text);
		}
		catch (IOException ioe)
		{
			JOptionPane.showMessageDialog(null, new JLabel("Error: " + ioe, JLabel.CENTER), "404: File Not Found", JOptionPane.ERROR_MESSAGE);
		}
	}
	public void fCompile() 
	{
		try
		{
			int i = 0;
			Runtime rt = Runtime.getRuntime();
			Process p = rt.exec(prefsObject.javacPath.toString() + " -Xstdout " + tPath.getText());

			InputStreamReader isr = new InputStreamReader(p.getInputStream());
			String text = new String("");
			while ( i != -1)
			{
				i = isr.read();
				text += (char)i ;
			}
			
			if ( text.length() > 5 )
			{
				JFrame output = new JFrame("Compiler Output");
				Container co = output.getContentPane();
				JLabel j = new JLabel("Output:");
				JTextArea j2 = new JTextArea( text, 20, 40);
				JScrollPane j2s = new JScrollPane(j2);
				co.add(j); co.add(j2s);

				//output.setSize(600, 400);
				output.pack();
				output.show();
			}
			else
			{
				JOptionPane.showMessageDialog(null, new Label("Compiled Successfully!"), "Compiler Output", JOptionPane.INFORMATION_MESSAGE );
			}
			

		} 
		catch (IOException ioe) 
		{
			System.out.println("Error: " + ioe);
		}
	}
	public void fRunApplication() //as application
	{
		String path;
		String temp = new String (tPath.getText());
		if ( temp.endsWith(".class") || temp.endsWith(".java") )
		{
			path = new String(temp.substring(0, temp.lastIndexOf(".")));
		}
		else
		{
			path = new String(temp);
		}
		try
		{
			int i = 0;
			Runtime rt = Runtime.getRuntime();
			Process p = rt.exec(prefsObject.javaPath.toString() + " " + path);

			JOptionPane.showMessageDialog(null, new JLabel("Java Program Running"), "Application Message", JOptionPane.INFORMATION_MESSAGE);
			/*InputStreamReader isr = new InputStreamReader(p.getInputStream());
			String text = new String("");
			while ( i != -1)
			{
				i = isr.read();
				text += (char)i ;
			}
			JFrame output = new JFrame("Application Output");
			Container co = output.getContentPane();
			JLabel j = new JLabel("OutPut");
			JTextArea j2 = new JTextArea("output:\n" + text, 25, 25);
			JScrollPane j2s = new JScrollPane(j2);
			co.add(j); co.add(j2s);
			
			output.setSize(600, 400);
			output.show();
			*/

		} 
		catch (IOException ioe) 
		{
			System.out.println("Error: " + ioe);
		}
	}
	public void fRunBrowser() 
	{ 
		String path;
		String temp = new String (tPath.getText());
		if ( temp.endsWith(".class") || temp.endsWith(".java") )
		{
			path = new String(temp.substring(0, temp.lastIndexOf(".")));
		}
		else
		{
			path = new String(temp);
		}
		path += ".html";
		File file = new File(path);

		try
		{
			Runtime rt = Runtime.getRuntime();
			Process p = rt.exec(prefsObject.browserPath.toString() + " " + file.getAbsolutePath());
		} 
		catch (IOException ioe) 
		{
			System.out.println("Error: " + ioe);
		}
	}
	public void fRunAppletviewer()
	{
		String path;
		String temp = new String (tPath.getText());
		if ( temp.endsWith(".class") || temp.endsWith(".java") )
		{
			path = new String(temp.substring(0, temp.lastIndexOf(".")));
		}
		else
		{
			path = new String(temp);
		}
		path += ".html";
                File file = new File (path);

		try
		{
			Runtime rt = Runtime.getRuntime();
                        Process p = rt.exec(prefsObject.appletviewerPath.toString() + " " + file.getAbsolutePath());
		} 
		catch (IOException ioe) 
		{
			System.out.println("Error: " + ioe);
		}
	}
	public void fGenHTML()
	{
		String temp = new String (tPath.getText());
		String path;

		if ( temp.endsWith(".class") || temp.endsWith(".java") )
		{
			path = new String(temp.substring(0, temp.lastIndexOf(".")));
		}
		else
		{
			path = new String(temp);
		}
		File file = new File(path + ".class");
                
                StringBuffer tempb = new StringBuffer
                (
                          "<html>\n"
			+ "\t<head>\n\t\t<title>"
			+ "Generated HTML File for Decaf Java Editor: "
			+ file.toString()
			+ "</title>\n\t</head>\n"
			+ "\n\n\t<body>\n"
			+ "\t\t<h1 align=\"center\">Generated HTML File for Decaf Java Editor:</h1>\n "
			+ "\t\t<h2 align=\"center\"><font color=blue>" + path + "</font></h2>\n\t\t<hr>\n\n"
                        + "\t\t<applet code=\"" + file.getName() + "\"\n\t "
                );

                //{ 
			try
                	{
                	        tempb.append( " codebase=\"" + file.getParentFile().toURL().toString() + "\"\n");
	                }
        	        catch (MalformedURLException m)
	                {
                	        System.out.println("Error: " + m);
        	        }

	                tempb.append( prefsObject.appletTag + " \n\t\t</applet>\n"
				+ "\n\n\t\t<hr>\n"
				+ "\t\t<center><small>&copy; 2000: " + companyName.toString() + "</small></center>\n"
				+ "\n\t</body>\n</html>"
			);
                //}
                String text = new String(tempb);

		path += ".html";
		try
		{
			FileWriter fw = new FileWriter(path);
			fw.write(text);
			fw.close();
		}
		catch (IOException e)
		{
                        JOptionPane.showMessageDialog(null, new JLabel("Error: " + e), "Error", JOptionPane.ERROR_MESSAGE);
		}
		JOptionPane.showMessageDialog(null, new JLabel("HTML File Generated Successfully!"), "HTML Generator Message", JOptionPane.INFORMATION_MESSAGE);
	}
	public void fPrefs()
	{
		final JFrame pf = new JFrame("Edit Prefs and Environment Vars");
		final JButton pDone, pCancel;
		final JTextField pText1, pText2, pText3, pText4, pText5, pText6, pText7;
		final JLabel pLabel1, pLabel2, pLabel3, pLabel4, pLabel5, 
			pLabel5b, pLabel6, pLabel7;

		Container c = pf.getContentPane();
		c.setLayout(new BoxLayout(c, BoxLayout.Y_AXIS));
		
		JPanel pRow1 = new JPanel();
		pRow1.setLayout(new BoxLayout(pRow1, BoxLayout.X_AXIS));
		pLabel1 = new JLabel("Java Path", JLabel.RIGHT);
		pText1 = new JTextField(prefsObject.javaPath, 30); //java
		pRow1.add(pLabel1); pRow1.add(pText1);

		JPanel pRow2 = new JPanel();
		pRow2.setLayout(new BoxLayout(pRow2, BoxLayout.X_AXIS));
		pLabel2 = new JLabel("JavaC Path", JLabel.RIGHT);
		pText2 = new JTextField(prefsObject.javacPath, 30); //javaC
		pRow2.add(pLabel2); pRow2.add(pText2);

		JPanel pRow3 = new JPanel();
		pRow3.setLayout(new BoxLayout(pRow3, BoxLayout.X_AXIS));
		pLabel3 = new JLabel("Appletviewer Path", JLabel.RIGHT);
		pText3 = new JTextField(prefsObject.appletviewerPath, 30); //appletviewer
		pRow3.add(pLabel3); pRow3.add(pText3);

		JPanel pRow4 = new JPanel();
		pRow4.setLayout(new BoxLayout(pRow4, BoxLayout.X_AXIS));
		pLabel4 = new JLabel("Browser Path", JLabel.RIGHT);
		pText4 = new JTextField(prefsObject.browserPath, 30); //Browser
		pRow4.add(pLabel4); pRow4.add(pText4);

		JPanel pRow5 = new JPanel();
		pRow5.setLayout(new BoxLayout(pRow5, BoxLayout.X_AXIS));
		pLabel5 = new JLabel("Applet Tag: <applet code=\" [filename] \" codebase=\" [path] \" ");
		pText5 = new JTextField(prefsObject.appletTag, 30); //applet Tag
		pLabel5b = new JLabel(" </applet>");
		pLabel5.setToolTipText("Edit the applet tag. ");
		pText5.setToolTipText("You can put in <PARAM> tags between the <APPLET> and </APPLET> tags");
		pRow5.add(pLabel5); pRow5.add(pText5); pRow5.add(pLabel5b);
		
		JPanel pRow6 = new JPanel();
		pRow6.setLayout(new BoxLayout(pRow6, BoxLayout.X_AXIS));
		pLabel6 = new JLabel("Cols", JLabel.RIGHT);
		pText6 = new JTextField(String.valueOf(prefsObject.cols), 5); //cols
		pRow6.add(pLabel6); pRow6.add(pText6);

		pLabel7 = new JLabel("Rows", JLabel.RIGHT);
		pText7 = new JTextField(String.valueOf(prefsObject.rows), 5); //rows
		pRow6.add(pLabel7); pRow6.add(pText7);

		JPanel pButtonRow = new JPanel();
		pDone = new JButton("Done - Save Prefs");
		pDone.addActionListener(new ActionListener()
		 {
			public void actionPerformed(ActionEvent e)
			{
				prefsObject.javaPath = pText1.getText();
				prefsObject.javacPath = pText2.getText();
				prefsObject.appletviewerPath = pText3.getText();
				prefsObject.browserPath = pText4.getText();
				prefsObject.appletTag = pText5.getText();
				prefsObject.cols = Integer.parseInt(pText6.getText());
				prefsObject.rows = Integer.parseInt(pText7.getText());
				
				try
				{
					prefsObject.write(prefsObject, "decaf.prefs");
				}
				catch (IOException g)
				{
					System.out.println("Error: " + g);
				}
				pf.dispose();
			}
		 }
		);
		pDone.setToolTipText("Save Prefs");

		pCancel = new JButton("Cancel");
		pCancel.addActionListener( new ActionListener()
		 {
			public void actionPerformed(ActionEvent e)
			{
				pf.dispose();
			}
		 }
		);
		pButtonRow.add(pDone); 
		pButtonRow.add(pCancel);

		c.add(pRow1);
		c.add(pRow2);
		c.add(pRow3);
		c.add(pRow4);
		c.add(pRow5);
		c.add(pRow6);
		c.add(pButtonRow);

		pf.setSize(new Dimension(600, 300));
		pf.show();
	}
}
